"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var BaseAction = /** @class */ (function () {
    function BaseAction(instanceName) {
        this.instanceName = instanceName;
        this.typePrefix = instanceName;
        this.successType = this.typePrefix + " success";
    }
    BaseAction.prototype.getSuccessType = function () {
        return this.successType;
    };
    BaseAction.prototype.setActionName = function (actionName) {
        this.typePrefix += "_" + actionName;
        this.onTypePrefixChanged();
    };
    // Only public method is required.
    BaseAction.prototype.proxy = function (fn, publicMethods, publicProperties) {
        var e_1, _a, e_2, _b;
        var _this = this;
        var handles = {};
        var methodNames = publicMethods.concat(['getSuccessType', 'setActionName']);
        var _loop_1 = function (method) {
            handles[method] = this_1[method].bind(this_1);
            Object.defineProperty(fn, method, {
                get: function () { return handles[method]; },
            });
        };
        var this_1 = this;
        try {
            for (var methodNames_1 = tslib_1.__values(methodNames), methodNames_1_1 = methodNames_1.next(); !methodNames_1_1.done; methodNames_1_1 = methodNames_1.next()) {
                var method = methodNames_1_1.value;
                _loop_1(method);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (methodNames_1_1 && !methodNames_1_1.done && (_a = methodNames_1.return)) _a.call(methodNames_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        var _loop_2 = function (property) {
            Object.defineProperty(fn, property, {
                get: function () { return _this[property]; },
            });
        };
        try {
            for (var publicProperties_1 = tslib_1.__values(publicProperties), publicProperties_1_1 = publicProperties_1.next(); !publicProperties_1_1.done; publicProperties_1_1 = publicProperties_1.next()) {
                var property = publicProperties_1_1.value;
                _loop_2(property);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (publicProperties_1_1 && !publicProperties_1_1.done && (_b = publicProperties_1.return)) _b.call(publicProperties_1);
            }
            finally { if (e_2) throw e_2.error; }
        }
        // Used for Proxy in BaseModel
        fn['__isAction__'] = true;
        return fn;
    };
    BaseAction.prototype.onTypePrefixChanged = function () {
        this.successType = this.typePrefix + " success";
    };
    return BaseAction;
}());
exports.BaseAction = BaseAction;
